// Bar.h : Declaration of the CBar

#pragma once
#include "resource.h"       // main symbols


// IBar
[
	object,
	uuid("17F38B1C-9D6A-45BD-A441-32B2B1A35101"),
	dual,	helpstring("IBar Interface"),
	pointer_default(unique)
]
__interface IBar : IDispatch
{
	[id(1), helpstring("method Another")] HRESULT Another(void);
};



// CBar

[
	coclass,
	threading("apartment"),
	vi_progid("SimpleServer.Bar"),
	progid("SimpleServer.Bar.1"),
	version(1.0),
	uuid("2D6F34F8-1AFB-4149-A69E-63C4360BBD92"),
	helpstring("Bar Class")
]
class ATL_NO_VTABLE CBar : 
	public IBar
{
public:
	CBar()
	{
	}


	DECLARE_PROTECT_FINAL_CONSTRUCT()

	HRESULT FinalConstruct()
	{
		return S_OK;
	}
	
	void FinalRelease() 
	{
	}

public:

	STDMETHOD(Another)(void);
};

